/*==================================================================
  ==================================================================
  ==	XMusic -- An Interactive Interface to Csound		  ==
  ==       Copyright (C) 1988 by George D. Drapeau                ==
  ==                  All Rights Reserved                         ==
  ==================================================================
  ==================================================================
*/
#include <X/Xlib.h>
#include <stdio.h>
#include <string.h>
#include "defs.h"
#include "externs.h"



SelectArg(event)
     XKeyOrButtonEvent	*event;
{
  int	whichArg;

  whichArg = (event->y+5) /(infoFont->height *1.5);		    /* Take into account for 1.5 line spacing */
  return(whichArg);
}								    /* end function SelectArg */




ChangeArg(event)
     XKeyOrButtonEvent	*event;
{
  int	whichArg, sLen;
  char	*argName, prompt[64];
  char	**destStr, *errFlg;
  char	*malloc(), tmpName[32];

  argName = NULL;
  whichArg = SelectArg(event);
  switch (whichArg)
    {
    case 1:
      argName = "Tool Name:";
      destStr = &lastTool->name;
      break;
    case 2:							    /* User clicked on Tool Rate, so change its value */
      if (lastTool->rate >=2)
	lastTool->rate = 0;
      else
	lastTool->rate++;
      changesMade = 1;
      DrawInfoWin(lastTool);
      return;
      break;
    case 3:
      argName = "Csound Function:";
      destStr = &lastTool->fName;
      break;
    case 4:
      argName = toolArg1;
      destStr = &lastTool->arg1;
      break;
    case 5:
      argName = toolArg2;
      destStr = &lastTool->arg2;
      break;
    case 6:
      argName = toolArg3;
      destStr = &lastTool->arg3;
      break;
    case 7:
      argName = toolArg4;
      destStr = &lastTool->arg4;
      break;
    case 8:
      argName = toolArg5;
      destStr = &lastTool->arg5;
      break;
    case 9:
      argName = toolArg6;
      destStr = &lastTool->arg6;
      break;
    case 10:
      argName = toolArg7;
      destStr = &lastTool->arg7;
      break;
    case 11:
      argName = toolArg8;
      destStr = &lastTool->arg8;
      break;
    default:
      printf("Not pointing to a changeable field.\n");
      return;
      break;
    }								    /* end switch whichArg... */
  if (argName == NULL)						    /* Is the user pointing to a valid string? */
    {
      printf("Not pointing to a changeable field.\n");		    /* No, tell the user of the error, and exit this... */
      errFlg=NULL;
      return;							    /* ...function without doing anything */
    }
  sprintf(prompt,"Enter Value for %s",argName);			    /* Set up the prompt string */
  sLen = EnterString(prompt);					    /* Get the parameter name from the user */
  if (sLen > 0)							    /* Did the user actually enter a string name? */
    {
      if (*destStr == NULL)					    /* Did the destination string have a previous value? */
	*destStr = malloc(MAXSTRLEN);				    /* No, allocate space for the value just entered */
      bzero(*destStr,MAXSTRLEN);				    /* Erase previous contents of the destination string */
      strncpy(*destStr, inputStr, sLen);			    /* Copy value entered to the appropriate tool parameter */
      changesMade = 1;						    /* Set flag saying that changes were made to the diagram */
      DrawInfoWin(lastTool);
    }								    /* end if */
}								    /* end function ChangeArg */
