/*==================================================================
  ==================================================================
  ==	XMusic -- An Interactive Interface to Csound		  ==
  ==       Copyright (C) 1988 by George D. Drapeau                ==
  ==                  All Rights Reserved                         ==
  ==================================================================
  ==================================================================
*/
#include <X/Xlib.h>
#include <stdio.h>
#include <string.h>
#include "defs.h"
#include "externs.h"



DrawInfoWin(tool)
     Tool	*tool;
{
  char		tempStr[32], RateToChar(), *RateToStr();
  int		argNum = 0;
  
  switch (tool->type)
    {
    case SineTool:
      sprintf(tempStr,"SineTool");
      break;
    case AmpTool:
      sprintf(tempStr,"AmpTool");
      break;
    case EQTool:
      sprintf(tempStr,"EQTool");
      break;
    case SumTool:
      sprintf(tempStr,"SumTool");
      break;
    case NoiseTool:
      sprintf(tempStr,"NoiseTool");
      break;
    case EnvTool:
      sprintf(tempStr,"EnvTool");
      break;
    case ParamTool:
      sprintf(tempStr,"ParamTool");
      break;
    }								    /* end switch */
  XClear(infoWin);
  XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum + 5),   /* Draw the first line of text, left side */
	"Tool Type:", strlen("Tool Type:"),
	infoFont->id, infoFG, infoBG);
  XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the first line of text, right side */
	(int)((infoFont->height * 1.5) * argNum + 5),
	tempStr, strlen(tempStr),
	infoFont->id, infoFG, infoBG);
  argNum++;							    /* Go on to the next line number in this window */
  XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum + 5),   /* Draw the second line of text, left side */
	"Tool Name:", strlen("Tool Name:"),
	infoFont->id, infoFG, infoBG);
  XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the second line of text, right side */
	(int)((infoFont->height * 1.5) * argNum + 5),
	tool->name, strlen(tool->name),
	infoFont->id, infoFG, infoBG);
  argNum++;							    /* Go on to the next line number in this window */
  XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum + 5),   /* Draw the third line of text, left side */
	"Tool Rate:", strlen("Tool Rate:"),
	infoFont->id, infoFG, infoBG);
  XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the third line of text, right side */
	(int)((infoFont->height * 1.5) * argNum + 5),
	RateToStr(tool->rate), strlen(RateToStr(tool->rate)),
	infoFont->id, infoFG, infoBG);
  argNum++;							    /* Go on to the next line number in this window */
  XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum + 5),   /* Draw the fourth line of text, left side */
	"Csound Function:", strlen("Csound Function:"),
	infoFont->id, infoFG, infoBG);
  XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the fourth line of text, right side */
	(int)((infoFont->height * 1.5) * argNum + 5),
	tool->fName, strlen(tool->fName),
	infoFont->id, infoFG, infoBG);
  argNum++;							    /* Go on to the next line number in this window */
  if (toolArg1)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg1);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input1)						    /* Does this tool have a first input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input1->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input1->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input1->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input1->rate),
		    tool->input1->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg1)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg1);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the first line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
  if (toolArg2)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg2);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input2)						    /* Does this tool have a second input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input2->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input2->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input2->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input2->rate),
		    tool->input2->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg2)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg2);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the second line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
  if (toolArg3)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg3);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input3)						    /* Does this tool have another input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input3->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input3->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input3->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input3->rate),
		    tool->input3->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg3)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg3);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the next line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
  if (toolArg4)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg4);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input4)						    /* Does this tool have another input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input4->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input4->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input4->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input4->rate),
		    tool->input4->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg4)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg4);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the next line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
  if (toolArg5)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg5);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input5)						    /* Does this tool have another input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input5->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input5->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input5->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input5->rate),
		    tool->input5->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg5)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg5);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the next line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
  if (toolArg6)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg6);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input6)						    /* Does this tool have another input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input6->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input6->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input6->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input6->rate),
		    tool->input6->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg6)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg6);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the next line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
  if (toolArg7)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg7);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input7)						    /* Does this tool have another input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input7->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input7->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input7->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input7->rate),
		    tool->input7->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg7)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg7);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the next line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
  if (toolArg8)							    /* Does the tool being examined have this argument?  */
    {
      sprintf(tempStr,"%d. %s",argNum-3,toolArg8);
      XText(infoWin, 5, (int)((infoFont->height * 1.5) * argNum+5), /* Yes, draw the argument's name and value */
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      if (tool->input8)						    /* Does this tool have another input? */
	{							    /* Yes, determine which name to use for the input name */
	  if ((tool->input8->type == EQTool) ||			    /* Use the equation or parameter name */
	      (tool->input8->type == ParamTool))
	    sprintf(tempStr,"%s",tool->input8->fName);
	  else							    /* Use the name of the tool */
	    sprintf(tempStr,"%c%s",RateToChar(tool->input8->rate),
		    tool->input8->name);
	}
      else							    /* No, this tool has not input, try to use default arg */
	{
	  if (tool->arg8)					    /* Does a default argument exist for this tool? */
	    sprintf(tempStr,"%s",tool->arg8);			    /* Yes, use it */
	  else							    /* No, print a blank string for the Info Window */
	    sprintf(tempStr," ");
	}
      XText(infoWin, (int)(infoFont->width * INFOSTRLEN + 5),	    /* Draw the last line of text, right side */
	    (int)((infoFont->height * 1.5) * argNum+5),
	    tempStr, strlen(tempStr),
	    infoFont->id, infoFG, infoBG);
      argNum++;							    /* Go on to the next line number in this window */
    }
  else
    return;
}								    /* end function DrawInfoWin */
